// 3vZWo͂ɏo(R\[AvP[V)

#include <stdio.h>
#include <iostream>
#include <tchar.h>
#include <complex>
#include <math.h>
#include <locale.h>

//	f̗vZ

std::complex<double>&  cubic_root(std::complex<double>& y, std::complex<double>& x){
	double z = abs(x);
	z = pow(z, 1.0 / 3.0);
	double t = arg(x)/3.0;
	y = std::complex<double>(z*cos(t), z*sin(t));
	return y;
}

// 3

void cubic_equation(std::complex<double>* x, double a, double b, double c, double d){
	std::complex<double> A,B3,C,D,E1,E2,T;

	A = std::complex<double>((27.0*a*a*d+2*b*b*b-9*a*b*c)/(54.0*a*a*a), 0);
	double b3=(3.0*a*c-b*b)/(9.0*a*a);
	B3 = std::complex<double>(b3*b3*b3,0);
	C = sqrt(A*A + B3);
	D = std::complex<double>( b/(3.0*a), 0);

	T = -A + C;
	E1 = cubic_root(E1,T);
	T = -A - C;
	E2 = cubic_root(E2, T); 

	x[0] = E1+E2-D;
	std::complex<double> W1, W2;

	W1 = (std::complex<double>(-1, 0) + std::complex<double>(sqrt(3.0), 0)*std::complex<double>(0, 1)) / std::complex<double>(2, 0);
	W2 = (std::complex<double>(-1, 0) - std::complex<double>(sqrt(3.0), 0)*std::complex<double>(0, 1)) / std::complex<double>(2, 0);

	x[1] = W1*E1 + W2*E2 - D;
	x[2] = W2*E1 + W1*E2 - D;
}

// Wo͂TCHARł쐬
#ifndef tcout
	#ifdef UNICODE
		#define tcout std::wcout
	#else
		#define tcout std::cout
	#endif
#endif

void _tmain(int argc,TCHAR** argv){
	//	UNICODEWo͂ɐ\邽߂ɃP[ݒ
	_tsetlocale(LC_ALL, _TEXT(""));
	std::complex<double> x[3];
	double a = _tcstod(argv[1],NULL);
	double b = _tcstod(argv[2],NULL);
	double c = _tcstod(argv[3],NULL);
	double d = _tcstod(argv[4],NULL);

	cubic_equation(x, a, b, c, d);

	tcout << a << _TEXT("x^3+") << b << _TEXT("x^2+") << c << _TEXT("x+") << d << _TEXT("=0\n");
	tcout << _TEXT("x0=") << x[0] << _TEXT("\n");
	tcout << _TEXT("x1=") << x[1] << _TEXT("\n");
	tcout << _TEXT("x2=") << x[2] << _TEXT("\n");
}
